import Combine

extension BusUI {
  public final class Value<T>: ObservableObject {
    @Published public var v: T
    var subscriptions = [AnyCancellable]()
   
    public init(
      _ key: String,
      _ defaultValue: T,
      _ id: String? = nil
    ) {
      v = defaultValue

      var k = key
      if let id {
        k = k + id
      }

      Bus.receiveSync(
        [k],
        { [weak self] (_, v: T) in self?.v = v },
        &subscriptions
      )
    }
  }
}
