import BusX
import SwiftUI

extension MeetupId {
  public struct V: View {
    @StateObject private var cmp: Component
    
    public init(_ id: String) {
      // https://stackoverflow.com/a/62636048
      _cmp = StateObject(wrappedValue: Component(id))
    }
    
    public var body: some View {
      VStack(spacing: 8) {
        HStack {
          TextField("Binding-3", value: $cmp.textField.v, formatter: BusUI.TextFieldSource())
            .disabled(cmp.isLoading.v)
            .padding(8)
            .border(
              !cmp.isLoading.v ? Color.black : Color.gray,
              width: !cmp.isLoading.v ? 2 : 1
            )
          if cmp.isLoading.v {
            ProgressView()
              .padding(8)
          }
        }

        Button(action: cmp.join.v.send) {
          Text("Join")
            .padding(8)
            .border(
              cmp.isJoinAvailable.v ? Color.green : Color.gray,
              width: cmp.isJoinAvailable.v ? 2 : 1
            )
        }
        .disabled(!cmp.isJoinAvailable.v)
      }
      .frame(width: 320)
      .padding()
      .animation(.easeInOut(duration: 0.3))
    }
  }
}
